import java.io.PrintStream;
import java.util.Scanner;

/**
 * @author Georgiy Korneev (kgeorgiy@kgeorgiy.info)
 */
public class sol_gk {
    private static Scanner in;
    private static PrintStream out;

    public static class Solution {
        public void run() {
            long n = in.nextInt();
            long m = in.nextInt();
            long c = in.nextInt();

            long best = n;
            long bestM = 0;
            long bestC = 0;
            

            for (long M = 0; M <= 2_000_000; M++) {
                long C = Math.max(0, (n - m * M) / c);
                if (best > Math.abs(m * M + c * C - n)) {
                    best = Math.abs(m * M + c * C - n);
                    bestM = M;
                    bestC = C;
                }
                C++;
                if (best > Math.abs(m * M + c * C - n)) {
                    best = Math.abs(m * M + c * C - n);
                    bestM = M;
                    bestC = C;
                }
            }
            out.println(bestM + " " + bestC);
        }
    }

    public static void main(String[] args) {
        in = new Scanner(System.in);
        out = System.out;

        new Solution().run();
    }
}
