/**
 *    author:  tourist
 *    created: 28.06.2021 20:46:58       
**/
#include <bits/stdc++.h>

using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int tt;
  cin >> tt;
  while (tt--) {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
      cin >> a[i];
    }
    vector<int> b(n);
    int ans = -1;
    int zone = -1;
    for (int t = 0; t < m; t++) {
      for (int i = 0; i < n; i++) {
        b[i] = (a[i] + t) / m;
      }
      int best = 1;
      int streak = 1;
      for (int i = 1; i < n; i++) {
        if (b[i] - b[i - 1] > 1) {
          streak = 1;
        } else {
          streak += b[i] - b[i - 1];
        }
        best = max(best, streak);
      }
      if (best > ans) {
        ans = best;
        zone = t;
      }
    }
    cout << ans << " " << zone << '\n';
  }
  return 0;
}
