/**
 *    author:  tourist
 *    created: 08.12.2021 03:42:19       
**/
#include <bits/stdc++.h>

using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n, L, V;
  cin >> n >> L >> V;
  vector<int> v(n);
  for (int i = 0; i < n; i++) {
    cin >> v[i];
  }
  assert(is_sorted(v.begin(), v.end()));
  // x >= L / v[i]   ->   L / v[i]
  // x <= L / v[i]   ->   x + 2 * (L - x * v[i]) / (V + v[i])
  //                    = x * (V - v[i]) / (V + v[i]) + 2 * L / (V + v[i])
  vector<double> pref_k(n + 1);
  vector<double> pref_b(n + 1);
  for (int i = 0; i < n; i++) {
    pref_k[i + 1] = pref_k[i] + (double) (V - v[i]) / (V + v[i]);
    pref_b[i + 1] = pref_b[i] + (double) 2 * L / (V + v[i]);
  }
  vector<double> suf_k(n + 1);
  vector<double> suf_b(n + 1);
  for (int i = n - 1; i >= 0; i--) {
    suf_k[i] = suf_k[i + 1] + 0;
    suf_b[i] = suf_b[i + 1] + (double) L / v[i];
  }
  double ans = 1e30;
  for (int i = 0; i <= n; i++) {
    double x = (i == n ? 0 : (double) L / v[i]);
    double cur = (pref_k[i] + suf_k[i]) * x + (pref_b[i] + suf_b[i]);
    ans = min(ans, cur);
  }
  cout << fixed << setprecision(13) << ans / n << '\n';
  return 0;
}
