#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#include "testlib.h"

int main(int argc, char *argv[]) {
    ios::sync_with_stdio(0);
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    int k = atoi(argv[3]);
    int mx = atoi(argv[4]);

    vector<vector<int>> l(k + 2);
    l[0] = {0};
    l[k + 1] = {n - 1};
    for (int i = 0; i < k; i++) {
        int ll = 1 + (n - 2) * i / k;
        int rr = 1 + (n - 2) * (i + 1) / k;
        for (int j = ll; j < rr; j++) {
            l[i + 1].push_back(j);
        }
    }

    set<pair<int, int>> e;
    for (int i = 1; i < (int)l.size() - 1; i++) {
        for (int x : l[i]) {
            e.insert({rnd.any(l[i - 1]), x});
            e.insert({x, rnd.any(l[i + 1])});
        }
    }
    while ((int)e.size() < m) {
        int i = rnd.next(1, (int)l.size() - 2);
        e.insert({rnd.any(l[i]), rnd.any(l[i + 1])});
    }

    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        a[i] = i + 1;
    }
    shuffle(a.begin() + 1, a.end() - 1);
    vector<pair<int, int>> ee;
    for (auto p : e) ee.push_back(p);
    shuffle(ee.begin(), ee.end());
    cout << n << " " << ee.size() << "\n";
    for (auto p : ee) {
        if (rnd.next(0, 1)) swap(p.first, p.second);
        cout << a[p.first] << " " << a[p.second] << " " << rnd.next(0, mx) << "\n";
    }
}
