#include <bits/stdc++.h>

#define long long long int
using namespace std;

// @author: pashka

int n, m;
vector<vector<pair<int, int>>> g;

void inverse() {
    for (int x = 0; x < n; x++) {
        for (auto &e: g[x]) e.second = -e.second;
    }
}

vector<int> d;
vector<int> w;
vector<int> p;
void go(int s) {
    d.assign(n, -1);
    d[s] = 0;
    vector<int> q;
    q.push_back(s);
    for (int i = 0; i < (int) q.size(); i++) {
        int x = q[i];
        for (auto &e : g[x]) {
            int y = e.first;
            if (d[y] == -1) {
                d[y] = d[x] + 1;
                q.push_back(y);
            }
        }
    }
    w.assign(n, INT_MIN);
    p.assign(n, -1);
    for (int x : q) {
        for (auto &e : g[x]) {
            int y = e.first;
            if (d[y] == d[x] + 1) {
                int ww = max(w[x], e.second);
                if (w[y] < ww) {
                    w[y] = ww;
                    p[y] = x;
                }
            }
        }
    }
}


int main() {
    ios::sync_with_stdio(false);

    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int x, y, c;
        cin >> x >> y >> c;
        x--;
        y--;
        g[x].push_back({y, c});
        g[y].push_back({x, c});
    }
    int res = INT_MIN;
    vector<int> resp;
    for (int t = 0; t < 2; t++) {
        go(0);
        auto dl = d;
        auto wl = w;
        auto pl = p;
        inverse();
        go(n - 1);
        auto dr = d;
        auto wr = w;
        auto pr = p;

        if (dl[n - 1] == 1) {
            res = 0;
            resp = {0, n - 1};
            break;
        }

        int besti = -1;
        for (int i = 1; i < n - 1; i++) {
            if (dl[i] + dr[i] == dl[n - 1]) {
                if (wl[i] + wr[i] > res) {
                    res = wl[i] + wr[i];
                    besti = i;
                }
            }
        }
        if (besti != -1) {
            int x = besti;
            resp.clear();
            while (x != -1) {
                resp.push_back(x);
                x = pl[x];
            }
            reverse(resp.begin(), resp.end());
            x = pr[besti];
            while (x != -1) {
                resp.push_back(x);
                x = pr[x];
            }
        }
    }
//    cerr << res << "\n";
    cout << resp.size() - 1 << "\n";
    for (int x : resp) cout << x + 1 << " ";

    return 0;
}