/**
 *    author:  tourist
 *    created: 08.12.2021 00:59:09       
**/
#include <bits/stdc++.h>

using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  vector<vector<pair<int, int>>> g(n);
  for (int i = 0; i < m; i++) {
    int x, y, z;
    cin >> x >> y >> z;
    --x; --y;
    g[x].emplace_back(y, z);
    g[y].emplace_back(x, z);
  }
  vector<int> order;
  vector<int> pvs;
  auto Bfs = [&](int start) {
    vector<int> d(n, -1);
    vector<int> pr(n, -1);
    vector<int> que(1, start);
    d[start] = 0;
    for (int b = 0; b < (int) que.size(); b++) {
      for (auto& p : g[que[b]]) {
        int to = p.first;
        if (d[to] == -1) {
          que.push_back(to);
          d[to] = d[que[b]] + 1;
          pr[to] = que[b];
        }
      }
    }
    if (start == 0) {
      order = que;
    } else {
      pvs = pr;
    }
    return d;
  };
  auto d1 = Bfs(0);
  auto d2 = Bfs(n - 1);
  int ans = -1;
  vector<int> best;
  for (int rot = 0; rot < 2; rot++) {
    vector<int> mx(n, -(int) 1e9);
    vector<int> from(n);
    for (int i : order) {
      for (auto& p : g[i]) {
        int to = p.first;
        if (d1[to] == d1[i] + 1) {
          int cur = max(mx[i], p.second);
          if (cur > mx[to]) {
            mx[to] = cur;
            from[to] = i;
          }
        }
      }
    }
    for (int i : order) {
      for (auto& p : g[i]) {
        int to = p.first;
        if (d1[to] == d1[i] + 1 && d2[to] + d1[to] == d1[n - 1]) {
          ans = max(ans, max(0, mx[i] - p.second));
        }
      }
    }
    bool done = false;
    for (int i : order) {
      for (auto& p : g[i]) {
        int to = p.first;
        if (d1[to] == d1[i] + 1 && d2[to] + d1[to] == d1[n - 1]) {
          if (max(0, mx[i] - p.second) == ans) {
            best.clear();
            int at = i;
            while (true) {
              best.push_back(at);
              if (at == 0) {
                break;
              }
              at = from[at];
            }
            reverse(best.begin(), best.end());
            at = to;
            while (true) {
              best.push_back(at);
              if (at == n - 1) {
                break;
              }
              at = pvs[at];
            }
            done = true;
            break;
          }
        }
      }
      if (done) {
        break;
      }
    }
    for (int i = 0; i < n; i++) {
      for (auto& p : g[i]) {
        p.second *= -1;
      }
    }
  }
  cout << best.size() - 1 << '\n';
  for (int i = 0; i < (int) best.size(); i++) {
    if (i > 0) {
      cout << " ";
    }
    cout << best[i] + 1;
  }
  cout << '\n';
  return 0;
}
