import random

test_num = 1

def make_date(num):
	if num < 0:
		return "%d BC" % (-num)
	else:
		return "AD %d" % (num)

def make_test(one, two):
	global test_num
	f = open("%02d" % test_num, "wt")
	f.write(make_date(one) + "\n")
	f.write(make_date(two) + "\n")
	f.close()
	test_num += 1

make_test (-1,1)
make_test (1,2001)
make_test (2022,-5508)

# order tests
for x in [-1,-2,1,2]:
	for y in [-1,-2,1,2]:
		if x==-1 and y==1: continue
		make_test(x,y)

# max tests
for x in [-1,1,-9999,9999]:
	for y in [-1,1,-9999,9999]:
		if abs(x)==1 and abs(y)==1: continue
		make_test(x,y)

# mid tests
for x in [1,-20,301,-4001]:
	for y in [-5,60,-701,8001]:
		make_test(x,y)

# random tests
random.seed(178123498)

for x in range(30):
	(a,b) = (0,0)
	while a==0 or b==0:
		a = random.randrange(-9999,9999)
		b = random.randrange(-9999,9999)
	make_test(a,b)
