/**
 *    author:  tourist
 *    created: 07.12.2021 23:37:54       
**/
#include <bits/stdc++.h>

using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n, k;
  cin >> n >> k;
  const int ALPHA = 26;
  vector<vector<int>> trie(1, vector<int>(ALPHA, -1));
  vector<int> mark(1, 0);
  for (int i = 0; i < n; i++) {
    string s;
    cin >> s;
    int t = 0;
    for (char c : s) {
      int d = (int) (c - 'a');
      if (trie[t][d] == -1) {
        trie[t][d] = (int) trie.size();
        trie.emplace_back(ALPHA, -1);
        mark.push_back(0);
      }
      t = trie[t][d];
    }
    mark[t] = 1;
  }
  int ans = 1;
  function<int(int)> Dfs = [&](int v) {
    vector<int> a;
    for (int u : trie[v]) {
      if (u != -1) {
        a.push_back(Dfs(u));
      }
    }
    sort(a.rbegin(), a.rend());
    if (mark[v]) {
      a.push_back(1);
    }
    int sum = accumulate(a.begin(), a.end(), 0);
    int ptr = 0;
    while (sum > k) {
      ans += 1;
      sum -= a[ptr++];
    }
    return sum;
  };
  Dfs(0);
  cout << ans << '\n';
  return 0;
}
