/**
 *    author:  tourist
 *    created: 28.06.2021 20:46:58       
**/
#include <bits/stdc++.h>

using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int tt;
  cin >> tt;
  while (tt--) {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
      cin >> a[i];
    }
    map<int, vector<int>> when;
    for (int i = 0; i < n; i++) {
      when[m - a[i] % m].push_back(i);
    }
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
      b[i] = a[i] / m;
    }
    auto Eval = [&]() {
      int best = 1;
      int streak = 1;
      for (int i = 1; i < n; i++) {
        if (b[i] - b[i - 1] > 1) {
          streak = 1;
        } else {
          streak += b[i] - b[i - 1];
        }
        best = max(best, streak);
      }
      return best;
    };
    int ans = Eval();
    int zone = 0;
    for (auto& e : when) {
      for (int i : e.second) {
        b[i] += 1;
      }
      int cur = Eval();
      if (cur > ans) {
        ans = cur;
        zone = e.first;
      }
    }
    cout << ans << " " << zone << '\n';
  }
  return 0;
}
