#include "testlib.h"

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    std::string line1 = inf.readLine("[A-Za-z\\:\\ ]{1,100}", "line 1");
    ensure(line1 == "Multiple local maxima: Yes" || line1 == "Multiple local maxima: No");

    std::string line2 = inf.readLine("[A-Za-z\\:\\ ]{1,100}", "line 2");
    ensure(line2 == "Multiple local minima: Yes" || line2 == "Multiple local minima: No");

    std::string line3 = inf.readLine("[A-Za-z\\:\\ ]{1,100}", "line 3");
    ensure(line3 == "Plateaus: Yes" || line3 == "Plateaus: No");

    inf.readEof();
    return 0;
}
